      subroutine hatdiag(nsct,ninp,ftsec,wt,hat,info)
c
c  rrrmt.9
c
c  computes diagonal of hat matrix 
c
c  input variables:
c
c  nsct--number of sections
c  ninp--number of variables
c  ftsec--complex array containing nsct section ffts for ninp variables
c  wt--weight vector
c
c  output variables:
c
c  hat--vector containing hat matrix diagonal
c  info--error flag, 0 for normal, otherwise as returned by zhifa
c
      include 'parameters.h'
      complex ftsec
      double complex a,atemp,zz
      dimension ftsec(nsectm,ninp),wt(nsct),hat(nsct)
      dimension a(nrefm,nrefm),ipvt(nrefm),zz(nrefm)
      info=0
      do 10 i=1,ninp
        do 10 j=i,ninp
          a(i,j)=0.
          do 10 ii=1,nsct
   10       a(i,j)=a(i,j)+wt(ii)**2*conjg(ftsec(ii,i))*
     $                         ftsec(ii,j)
      call zhifa(a,nrefm,ninp,ipvt,info)
      job=001
      call zhidi(a,nrefm,ninp,ipvt,det,inert,zz,job)
      do 20 i=1,ninp
        do 20 j=i+1,ninp
   20     a(j,i)=conjg(a(i,j))
      do 30 j=1,nsct
        hat(j)=0.
        do 30 i=1,ninp
          atemp=0.
          do 25 jj=1,ninp
   25       atemp=atemp+a(i,jj)*wt(j)*conjg(ftsec(j,jj))
   30      hat(j)=hat(j)+wt(j)*real(ftsec(j,i)*atemp)
      return
      end
