      subroutine input(filnam,form,nblock,nskip,npts,data)
      character*(*) filnam,form
      dimension data(1),record(30000)
      if(((form.eq.'u').or.(form.eq.'U')).and.(nblock.eq.0))goto 100
      if((form.eq.'f').or.(form.eq.'F'))goto 200
      open (unit=10,name=filnam,status='old',form='unformatted')
      nrecs=nskip/nblock
      nlefs=nskip-nblock*nrecs
      do 10 i=1,nrecs
   10   read(10)(record(j),j=1,nblock)
      k=1
      if(nlefs.eq.0)goto 30
      read(10,end=300)(record(i),i=1,nblock)
      do 20 i=nlefs+1,min(nblock,npts+nlefs)
        data(k)=record(i)
   20   k=k+1
   30 continue
      nread=npts-k+1
      nrec=nread/nblock
      nleft=nread-nblock*nrec
      do 40 j=1,nrec
        read(10,end=300)(record(i),i=1,nblock)
        do 35 i=1,nblock
          data(k)=record(i)
   35     k=k+1
   40 continue
      if(nleft.eq.0)goto 300
      read(10,end=300)(record(i),i=1,nblock)
      do 50 i=1,nleft
        data(k)=record(i)
   50   k=k+1
      goto 300
  100 continue
      open (unit=10,name=filnam,status='old',form='unformatted')
      do 110 i=1,nskip
  110   read(10)
      do 120 k=1,npts
  120   read(10,end=300)data(k)
      goto 300
  200 continue
      open (unit=10,name=filnam,status='old')
      do 210 i=1,nskip
  210   read(10,*)
      do 220 k=1,npts
  220   read(10,*,end=300)data(k)
  300 npts=k-1
      close (unit=10)
      return
      end
      real function r1mach(i)
c***purpose  returns single precision machine dependent constants
c***description
c
c     r1mach can be used to obtain machine-dependent parameters
c     for the local machine environment.  it is a function
c     subroutine with one (input) argument, and can be called
c     as follows, for example
c
c          a = r1mach(i)
c
c     where i=1,...,5.  the (output) value of a above is
c     determined by the (input) value of i.  the results for
c     various values of i are discussed below.
c
c  single-precision machine constants
c  r1mach(1) = b**(emin-1), the smallest positive magnitude.
c  r1mach(2) = b**emax*(1 - b**(-t)), the largest magnitude.
c  r1mach(3) = b**(-t), the smallest relative spacing.
c  r1mach(4) = b**(1-t), the largest relative spacing.
c  r1mach(5) = log10(b)
c***references  fox, p.a., hall, a.d., schryer, n.l, *framework for
c                 a portable library*, acm transactions on mathe-
c                 matical software, vol. 4, no. 2, june 1978,
c                 pp. 177-188.
c***routines called  none
c
c  constants for alliant or  sun computed using
c  should be good for any ieee standard machine
c    b=2
c    t=24
c    emin=-125
c    emax=128
      dimension rmach(5),imach(5)
      equivalence (rmach,imach)
      data (imach(j),j=1,5)/
     $     8388608,2139095039,864026624,872415232,
     $     1050288283/
      r1mach=rmach(i)
      return
      end
      double precision function d1mach(i)
c
c  double-precision machine constants
c
c  d1mach( 1) = b**(emin-1), the smallest positive magnitude.
c
c  d1mach( 2) = b**emax*(1 - b**(-t)), the largest magnitude.
c
c  d1mach( 3) = b**(-t), the smallest relative spacing.
c
c  d1mach( 4) = b**(1-t), the largest relative spacing.
c
c  d1mach( 5) = log10(b)
c
c  to alter this function for a particular environment,
c  the desired set of data statements should be activated by
c  removing the c from column 1.
c  on rare machines a static statement may need to be added.
c  (but probably more systems prohibit it than require it.)
c
c  for ieee-arithmetic machines (binary standard), one of the first
c  two sets of constants below should be appropriate.  if you do not
c  know which set to use, try both and see which gives plausible
c  values.
c
c  where possible, decimal, octal or hexadecimal constants are used
c  to specify the constants exactly.  sometimes this requires using
c  equivalent integer arrays.  if your compiler uses half-word
c  integers by default (sometimes called integer*2), you may need to
c  change integer to integer*4 or otherwise instruct your compiler
c  to use full-word integers in the next 5 declarations.
c
c  comments just before the end statement (lines starting with *)
c  give c source for d1mach.
c
      integer small(2)
      integer large(2)
      integer right(2)
      integer diver(2)
      integer log10(2)
      integer sc
c
      double precision dmach(5)
c
      equivalence (dmach(1),small(1))
      equivalence (dmach(2),large(1))
      equivalence (dmach(3),right(1))
      equivalence (dmach(4),diver(1))
      equivalence (dmach(5),log10(1))
c
c     machine constants for big-endian ieee arithmetic (binary format)
c     machines in which the most significant byte is stored first,
c     such as the at&t 3b series, motorola 68000 based machines (e.g.
c     sun 3), and machines that use sparc, hp, or ibm risc chips.
c
      data small(1),small(2) /    1048576,          0 /
      data large(1),large(2) / 2146435071,         -1 /
      data right(1),right(2) / 1017118720,          0 /
      data diver(1),diver(2) / 1018167296,          0 /
      data log10(1),log10(2) / 1070810131, 1352628735 /, sc/987/
c
c     machine constants for little-endian (binary) ieee arithmetic
c     machines in which the least significant byte is stored first,
c     e.g. ibm pcs and other machines that use intel 80x87 or dec
c     alpha chips.
c
c      data small(1),small(2) /          0,    1048576 /
c      data large(1),large(2) /         -1, 2146435071 /
c      data right(1),right(2) /          0, 1017118720 /
c      data diver(1),diver(2) /          0, 1018167296 /
c      data log10(1),log10(2) / 1352628735, 1070810131 /, sc/987/
c
c     machine constants for amdahl machines.
c
c      data small(1),small(2) /    1048576,          0 /
c      data large(1),large(2) / 2147483647,         -1 /
c      data right(1),right(2) /  856686592,          0 /
c      data diver(1),diver(2) /  873463808,          0 /
c      data log10(1),log10(2) / 1091781651, 1352628735 /, sc/987/
c
c     machine constants for the burroughs 1700 system.
c
c      data small(1) / zc00800000 /
c      data small(2) / z000000000 /
c
c      data large(1) / zdffffffff /
c      data large(2) / zfffffffff /
c
c      data right(1) / zcc5800000 /
c      data right(2) / z000000000 /
c
c      data diver(1) / zcc6800000 /
c      data diver(2) / z000000000 /
c
c      data log10(1) / zd00e730e7 /
c      data log10(2) / zc77800dc0 /, sc/987/
c
c     machine constants for the burroughs 5700 system.
c
c      data small(1) / o1771000000000000 /
c      data small(2) / o0000000000000000 /
c
c      data large(1) / o0777777777777777 /
c      data large(2) / o0007777777777777 /
c
c      data right(1) / o1461000000000000 /
c      data right(2) / o0000000000000000 /
c
c      data diver(1) / o1451000000000000 /
c      data diver(2) / o0000000000000000 /
c
c      data log10(1) / o1157163034761674 /
c      data log10(2) / o0006677466732724 /, sc/987/
c
c     machine constants for the burroughs 6700/7700 systems.
c
c      data small(1) / o1771000000000000 /
c      data small(2) / o7770000000000000 /
c
c      data large(1) / o0777777777777777 /
c      data large(2) / o7777777777777777 /
c
c      data right(1) / o1461000000000000 /
c      data right(2) / o0000000000000000 /
c
c      data diver(1) / o1451000000000000 /
c      data diver(2) / o0000000000000000 /
c
c      data log10(1) / o1157163034761674 /
c      data log10(2) / o0006677466732724 /, sc/987/
c
c     machine constants for ftn4 on the cdc 6000/7000 series.
c
c      data small(1) / 00564000000000000000b /
c      data small(2) / 00000000000000000000b /
c
c      data large(1) / 37757777777777777777b /
c      data large(2) / 37157777777777777774b /
c
c      data right(1) / 15624000000000000000b /
c      data right(2) / 00000000000000000000b /
c
c      data diver(1) / 15634000000000000000b /
c      data diver(2) / 00000000000000000000b /
c
c      data log10(1) / 17164642023241175717b /
c      data log10(2) / 16367571421742254654b /, sc/987/
c
c     machine constants for ftn5 on the cdc 6000/7000 series.
c
c      data small(1) / o"00564000000000000000" /
c      data small(2) / o"00000000000000000000" /
c
c      data large(1) / o"37757777777777777777" /
c      data large(2) / o"37157777777777777774" /
c
c      data right(1) / o"15624000000000000000" /
c      data right(2) / o"00000000000000000000" /
c
c      data diver(1) / o"15634000000000000000" /
c      data diver(2) / o"00000000000000000000" /
c
c      data log10(1) / o"17164642023241175717" /
c      data log10(2) / o"16367571421742254654" /, sc/987/
c
c     machine constants for convex c-1
c
c      data small(1),small(2) / '00100000'x, '00000000'x /
c      data large(1),large(2) / '7fffffff'x, 'ffffffff'x /
c      data right(1),right(2) / '3cc00000'x, '00000000'x /
c      data diver(1),diver(2) / '3cd00000'x, '00000000'x /
c      data log10(1),log10(2) / '3ff34413'x, '509f79ff'x /, sc/987/
c
c     machine constants for the cray 1, xmp, 2, and 3.
c
c      data small(1) / 201354000000000000000b /
c      data small(2) / 000000000000000000000b /
c
c      data large(1) / 577767777777777777777b /
c      data large(2) / 000007777777777777776b /
c
c      data right(1) / 376434000000000000000b /
c      data right(2) / 000000000000000000000b /
c
c      data diver(1) / 376444000000000000000b /
c      data diver(2) / 000000000000000000000b /
c
c      data log10(1) / 377774642023241175717b /
c      data log10(2) / 000007571421742254654b /, sc/987/
c
c     machine constants for the data general eclipse s/200
c
c     small, large, right, diver, log10 should be declared
c     integer small(4), large(4), right(4), diver(4), log10(4)
c
c     note - it may be appropriate to include the following line -
c     static dmach(5)
c
c      data small/20k,3*0/,large/77777k,3*177777k/
c      data right/31420k,3*0/,diver/32020k,3*0/
c      data log10/40423k,42023k,50237k,74776k/, sc/987/
c
c     machine constants for the harris slash 6 and slash 7
c
c      data small(1),small(2) / '20000000, '00000201 /
c      data large(1),large(2) / '37777777, '37777577 /
c      data right(1),right(2) / '20000000, '00000333 /
c      data diver(1),diver(2) / '20000000, '00000334 /
c      data log10(1),log10(2) / '23210115, '10237777 /, sc/987/
c
c     machine constants for the honeywell dps 8/70 series.
c
c      data small(1),small(2) / o402400000000, o000000000000 /
c      data large(1),large(2) / o376777777777, o777777777777 /
c      data right(1),right(2) / o604400000000, o000000000000 /
c      data diver(1),diver(2) / o606400000000, o000000000000 /
c      data log10(1),log10(2) / o776464202324, o117571775714 /, sc/987/
c
c     machine constants for the ibm 360/370 series,
c     the xerox sigma 5/7/9 and the sel systems 85/86.
c
c      data small(1),small(2) / z00100000, z00000000 /
c      data large(1),large(2) / z7fffffff, zffffffff /
c      data right(1),right(2) / z33100000, z00000000 /
c      data diver(1),diver(2) / z34100000, z00000000 /
c      data log10(1),log10(2) / z41134413, z509f79ff /, sc/987/
c
c     machine constants for the interdata 8/32
c     with the unix system fortran 77 compiler.
c
c     for the interdata fortran vii compiler replace
c     the z's specifying hex constants with y's.
c
c      data small(1),small(2) / z'00100000', z'00000000' /
c      data large(1),large(2) / z'7effffff', z'ffffffff' /
c      data right(1),right(2) / z'33100000', z'00000000' /
c      data diver(1),diver(2) / z'34100000', z'00000000' /
c      data log10(1),log10(2) / z'41134413', z'509f79ff' /, sc/987/
c
c     machine constants for the pdp-10 (ka processor).
c
c      data small(1),small(2) / "033400000000, "000000000000 /
c      data large(1),large(2) / "377777777777, "344777777777 /
c      data right(1),right(2) / "113400000000, "000000000000 /
c      data diver(1),diver(2) / "114400000000, "000000000000 /
c      data log10(1),log10(2) / "177464202324, "144117571776 /, sc/987/
c
c     machine constants for the pdp-10 (ki processor).
c
c      data small(1),small(2) / "000400000000, "000000000000 /
c      data large(1),large(2) / "377777777777, "377777777777 /
c      data right(1),right(2) / "103400000000, "000000000000 /
c      data diver(1),diver(2) / "104400000000, "000000000000 /
c      data log10(1),log10(2) / "177464202324, "047674776746 /, sc/987/
c
c     machine constants for pdp-11 fortrans supporting
c     32-bit integers (expressed in integer and octal).
c
c      data small(1),small(2) /    8388608,           0 /
c      data large(1),large(2) / 2147483647,          -1 /
c      data right(1),right(2) /  612368384,           0 /
c      data diver(1),diver(2) /  620756992,           0 /
c      data log10(1),log10(2) / 1067065498, -2063872008 /, sc/987/
c
c      data small(1),small(2) / o00040000000, o00000000000 /
c      data large(1),large(2) / o17777777777, o37777777777 /
c      data right(1),right(2) / o04440000000, o00000000000 /
c      data diver(1),diver(2) / o04500000000, o00000000000 /
c      data log10(1),log10(2) / o07746420232, o20476747770 /, sc/987/
c
c     machine constants for pdp-11 fortrans supporting
c     16-bit integers (expressed in integer and octal).
c
c     small, large, right, diver, log10 should be declared
c     integer small(4), large(4), right(4), diver(4), log10(4)
c
c      data small(1),small(2) /    128,      0 /
c      data small(3),small(4) /      0,      0 /
c
c      data large(1),large(2) /  32767,     -1 /
c      data large(3),large(4) /     -1,     -1 /
c
c      data right(1),right(2) /   9344,      0 /
c      data right(3),right(4) /      0,      0 /
c
c      data diver(1),diver(2) /   9472,      0 /
c      data diver(3),diver(4) /      0,      0 /
c
c      data log10(1),log10(2) /  16282,   8346 /
c      data log10(3),log10(4) / -31493, -12296 /, sc/987/
c
c      data small(1),small(2) / o000200, o000000 /
c      data small(3),small(4) / o000000, o000000 /
c
c      data large(1),large(2) / o077777, o177777 /
c      data large(3),large(4) / o177777, o177777 /
c
c      data right(1),right(2) / o022200, o000000 /
c      data right(3),right(4) / o000000, o000000 /
c
c      data diver(1),diver(2) / o022400, o000000 /
c      data diver(3),diver(4) / o000000, o000000 /
c
c      data log10(1),log10(2) / o037632, o020232 /
c      data log10(3),log10(4) / o102373, o147770 /, sc/987/
c
c     machine constants for the prime 50 series systems
c     with 32-bit integers and 64v mode instructions,
c     supplied by igor bray.
c
c      data small(1),small(2) / :10000000000, :00000100001 /
c      data large(1),large(2) / :17777777777, :37777677775 /
c      data right(1),right(2) / :10000000000, :00000000122 /
c      data diver(1),diver(2) / :10000000000, :00000000123 /
c      data log10(1),log10(2) / :11504046501, :07674600177 /, sc/987/
c
c     machine constants for the sequent balance 8000
c
c      data small(1),small(2) / $00000000,  $00100000 /
c      data large(1),large(2) / $ffffffff,  $7fefffff /
c      data right(1),right(2) / $00000000,  $3ca00000 /
c      data diver(1),diver(2) / $00000000,  $3cb00000 /
c      data log10(1),log10(2) / $509f79ff,  $3fd34413 /, sc/987/
c
c     machine constants for the univac 1100 series.
c
c      data small(1),small(2) / o000040000000, o000000000000 /
c      data large(1),large(2) / o377777777777, o777777777777 /
c      data right(1),right(2) / o170540000000, o000000000000 /
c      data diver(1),diver(2) / o170640000000, o000000000000 /
c      data log10(1),log10(2) / o177746420232, o411757177572 /, sc/987/
c
c     machine constants for the vax unix f77 compiler
c
c      data small(1),small(2) /        128,           0 /
c      data large(1),large(2) /     -32769,          -1 /
c      data right(1),right(2) /       9344,           0 /
c      data diver(1),diver(2) /       9472,           0 /
c      data log10(1),log10(2) /  546979738,  -805796613 /, sc/987/
c
c     machine constants for the vax-11 with
c     fortran iv-plus compiler
c
c      data small(1),small(2) / z00000080, z00000000 /
c      data large(1),large(2) / zffff7fff, zffffffff /
c      data right(1),right(2) / z00002480, z00000000 /
c      data diver(1),diver(2) / z00002500, z00000000 /
c      data log10(1),log10(2) / z209a3f9a, zcff884fb /, sc/987/
c
c     machine constants for vax/vms version 2.2
c
c      data small(1),small(2) /       '80'x,        '0'x /
c      data large(1),large(2) / 'ffff7fff'x, 'ffffffff'x /
c      data right(1),right(2) /     '2480'x,        '0'x /
c      data diver(1),diver(2) /     '2500'x,        '0'x /
c      data log10(1),log10(2) / '209a3f9a'x, 'cff884fb'x /, sc/987/
c
c  ***  issue stop 779 if all data statements are commented...
c      if (sc .ne. 987) stop 779
c  ***  issue stop 778 if all data statements are obviously wrong...
c      if (dmach(4) .ge. 1.0d0) stop 778
c      if (i .lt. 1  .or.  i .gt. 5) goto 999
      d1mach = dmach(i)
      return
c  999 write(*,1999) i
c 1999 format(' d1mach - i out of bounds',i10)
c      stop
      end
      function phase(z)
      parameter(pi=3.1415926535,deg=180./pi)
      complex z
      z1=real(z)
      z2=aimag(z)
      if((z1.ne.0.).and.(z2.ne.0.))then
        phase=deg*atan2(z2,z1)
      else
        phase=0.
      endif
      return
      end 
      logical function compare(x1,x2,n)
c  compares two floating point numbers and returns .true.
c  if their mantissas are the same to n significant figures
      compare=.false.
      j=int(log10(x1))
      if(j.ne.int(log10(x2)))return
      ix1=int(10.**(-j+n)*x1)
      ix2=int(10.**(-j+n)*x2)
      if(ix1.ne.ix2)return
      compare=.true.
      return
      end
      subroutine ssort(x,y,n,kflag)
c***begin prologue  ssort
c***date written   761101   (yymmdd)
c***revision date  820801   (yymmdd)
c***category no.  n6a2b1
c***keywords  quicksort,singleton quicksort,sort,sorting
c***author  jones, r. e., (snla)
c           wisniewski, j. a., (snla)
c***purpose  ssort sorts array x and optionally makes the same
c            interchanges in array y.  the array x may be sorted in
c            increasing order or decreasing order.  a slightly modified
c            quicksort algorithm is used.
c***description
c
c     written by rondall e. jones
c     modified by john a. wisniewski to use the singleton quicksort
c     algorithm.  date 18 november 1976.
c
c     abstract
c         ssort sorts array x and optionally makes the same
c         interchanges in array y.  the array x may be sorted in
c         increasing order or decreasing order.  a slightly modified
c         quicksort algorithm is used.
c
c     reference
c         singleton, r. c., algorithm 347, an efficient algorithm for
c         sorting with minimal storage, cacm,12(3),1969,185-7.
c
c     description of parameters
c         x - array of values to be sorted   (usually abscissas)
c         y - array to be (optionally) carried along
c         n - number of values in array x to be sorted
c         kflag - control parameter
c             =2  means sort x in increasing order and carry y along.
c             =1  means sort x in increasing order (ignoring y)
c             =-1 means sort x in decreasing order (ignoring y)
c             =-2 means sort x in decreasing order and carry y along.
c***references  singleton,r.c., algorithm 347, an efficient algorithm
c                 for sorting with minimal storage, cacm,12(3),1969,
c                 185-7.
c***routines called  none
c***end prologue  ssort
      include 'parameters.h'
      dimension x(n),y(n),il(21),iu(21)
c***first executable statement  ssort
      nn = n
      if (nn.ge.1) go to 10
      if(inter)then
        write(6,*)' the number of values to be sorted was not positive'
      else
        write(nerr,*)
     $        ' the number of values to be sorted was not positive'
      endif
      return
   10 kk = iabs(kflag)
      if ((kk.eq.1).or.(kk.eq.2)) go to 15
      if(inter)then
        write(6,*)' the sort control parameter, k,was not 2,1,-1, or -2'
      else
        write(nerr,*)
     $        ' the sort control parameter, k,was not 2,1,-1, or -2'
      endif
      return
c
c alter array x to get decreasing order if needed
c
   15 if (kflag.ge.1) go to 30
      do 20 i=1,nn
   20 x(i) = -x(i)
   30 go to (100,200),kk
c
c sort x only
c
  100 continue
      m=1
      i=1
      j=nn
      r=.375
  110 if (i .eq. j) go to 155
  115 if (r .gt. .5898437) go to 120
      r=r+3.90625e-2
      go to 125
  120 r=r-.21875
  125 k=i
c                                  select a central element of the
c                                  array and save it in location t
      ij = i + ifix (float (j-i) * r)
      t=x(ij)
c                                  if first element of array is greater
c                                  than t, interchange with t
      if (x(i) .le. t) go to 130
      x(ij)=x(i)
      x(i)=t
      t=x(ij)
  130 l=j
c                                  if last element of array is less thans
c                                  t, interchange with t
      if (x(j) .ge. t) go to 140
      x(ij)=x(j)
      x(j)=t
      t=x(ij)
c                                  if first element of array is greater
c                                  than t, interchange with t
      if (x(i) .le. t) go to 140
      x(ij)=x(i)
      x(i)=t
      t=x(ij)
      go to 140
  135 tt=x(l)
      x(l)=x(k)
      x(k)=tt
c                                  find an element in the second half ofs
c                                  the array which is smaller than t
  140 l=l-1
      if (x(l) .gt. t) go to 140
c                                  find an element in the first half of
c                                  the array which is greater than t
  145 k=k+1
      if (x(k) .lt. t) go to 145
c                                  interchange these elements
      if (k .le. l) go to 135
c                                  save upper and lower subscripts of
c                                  the array yet to be sorted
      if (l-i .le. j-k) go to 150
      il(m)=i
      iu(m)=l
      i=k
      m=m+1
      go to 160
  150 il(m)=k
      iu(m)=j
      j=l
      m=m+1
      go to 160
c                                  begin again on another portion of
c                                  the unsorted array
  155 m=m-1
      if (m .eq. 0) go to 300
      i=il(m)
      j=iu(m)
  160 if (j-i .ge. 1) go to 125
      if (i .eq. 1) go to 110
      i=i-1
  165 i=i+1
      if (i .eq. j) go to 155
      t=x(i+1)
      if (x(i) .le. t) go to 165
      k=i
  170 x(k+1)=x(k)
      k=k-1
      if (t .lt. x(k)) go to 170
      x(k+1)=t
      go to 165
c
c sort x and carry y along
c
  200 continue
      m=1
      i=1
      j=nn
      r=.375
  210 if (i .eq. j) go to 255
  215 if (r .gt. .5898437) go to 220
      r=r+3.90625e-2
      go to 225
  220 r=r-.21875
  225 k=i
c                                  select a central element of the
c                                  array and save it in location t
      ij = i + ifix (float (j-i) *r)
      t=x(ij)
      ty= y(ij)
c                                  if first element of array is greater
c                                  than t, interchange with t
      if (x(i) .le. t) go to 230
      x(ij)=x(i)
      x(i)=t
      t=x(ij)
       y(ij)= y(i)
       y(i)=ty
      ty= y(ij)
  230 l=j
c                                  if last element of array is less thans
c                                  t, interchange with t
      if (x(j) .ge. t) go to 240
      x(ij)=x(j)
      x(j)=t
      t=x(ij)
       y(ij)= y(j)
       y(j)=ty
      ty= y(ij)
c                                  if first element of array is greater
c                                  than t, interchange with t
      if (x(i) .le. t) go to 240
      x(ij)=x(i)
      x(i)=t
      t=x(ij)
       y(ij)= y(i)
       y(i)=ty
      ty= y(ij)
      go to 240
  235 tt=x(l)
      x(l)=x(k)
      x(k)=tt
      tty= y(l)
       y(l)= y(k)
       y(k)=tty
c                                  find an element in the second half ofs
c                                  the array which is smaller than t
  240 l=l-1
      if (x(l) .gt. t) go to 240
c                                  find an element in the first half of
c                                  the array which is greater than t
  245 k=k+1
      if (x(k) .lt. t) go to 245
c                                  interchange these elements
      if (k .le. l) go to 235
c                                  save upper and lower subscripts of
c                                  the array yet to be sorted
      if (l-i .le. j-k) go to 250
      il(m)=i
      iu(m)=l
      i=k
      m=m+1
      go to 260
  250 il(m)=k
      iu(m)=j
      j=l
      m=m+1
      go to 260
c                                  begin again on another portion of
c                                  the unsorted array
  255 m=m-1
      if (m .eq. 0) go to 300
      i=il(m)
      j=iu(m)
  260 if (j-i .ge. 1) go to 225
      if (i .eq. 1) go to 210
      i=i-1
  265 i=i+1
      if (i .eq. j) go to 255
      t=x(i+1)
      ty= y(i+1)
      if (x(i) .le. t) go to 265
      k=i
  270 x(k+1)=x(k)
       y(k+1)= y(k)
      k=k-1
      if (t .lt. x(k)) go to 270
      x(k+1)=t
       y(k+1)=ty
      go to 265
c
c clean up
c
  300 if (kflag.ge.1) return
      do 310 i=1,nn
  310 x(i) = -x(i)
      return
      end
      function lenb(string)
c  finds index of last nonblank character in string
      character*(*) string
      n=len(string)
      do 10 i=n,1,-1
        if(string(i:i).ne.' ')then
          lenb=i
          return
        endif
   10 continue
      lenb=0
      return
      end
      SUBROUTINE FZERO(F,B,C,R,RE,AE,IFLAG,RPAR,IPAR)
C***BEGIN PROLOGUE  FZERO
C***DATE WRITTEN   700901   (YYMMDD)
C***REVISION DATE  820801   (YYMMDD)
C***CATEGORY NO.  F1B
C***KEYWORDS  BISECTION,NONLINEAR,ROOTS,ZEROS
C***AUTHOR  SHAMPINE,L.F.,SNLA
C           WATTS,H.A.,SNLA
C***PURPOSE  FZERO searches for a zero of a function F(X) in a given
C            interval (B,C).  It is designed primarily for problems
C            where F(B) and F(C) have opposite signs.
C***DESCRIPTION
C
C     Based on a method by T J Dekker
C     written by L F Shampine and H A Watts
C
C            FZERO searches for a zero of a function F(X) between
C            the given values B and C until the width of the interval
C            (B,C) has collapsed to within a tolerance specified by
C            the stopping criterion, ABS(B-C) .LE. 2.*(RW*ABS(B)+AE).
C            The method used is an efficient combination of bisection
C            and the secant rule.
C
C     Description Of Arguments
C
C     F,B,C,R,RE and AE are input parameters
C     B,C and IFLAG are output parameters (flagged by an * below)
C
C        F     - Name of the real valued external function.  This name
C                must be in an EXTERNAL statement in the calling
C                program.  F must be a function of one real argument.
C
C       *B     - One end of the interval (B,C).  The value returned for
C                B usually is the better approximation to a zero of F.
C
C       *C     - The other end of the interval (B,C)
C
C        R     - A (better) guess of a zero of F which could help in
C                speeding up convergence.  If F(B) and F(R) have
C                opposite signs, a root will be found in the interval
C                (B,R); if not, but F(R) and F(C) have opposite
C                signs, a root will be found in the interval (R,C);
C                otherwise, the interval (B,C) will be searched for a
C                possible root.  When no better guess is known, it is
C                recommended that r be set to B or C; because if R is
C                not interior to the interval (B,C), it will be ignored.
C
C        RE    - Relative error used for RW in the stopping criterion.
C                If the requested RE is less than machine precision,
C                then RW is set to approximately machine precision.
C
C        AE    - Absolute error used in the stopping criterion.  If the
C                given interval (B,C) contains the origin, then a
C                nonzero value should be chosen for AE.
C
C       *IFLAG - A status code.  User must check IFLAG after each call.
C                Control returns to the user from FZERO in all cases.
C                XERROR does not process diagnostics in these cases.
C
C                1  B is within the requested tolerance of a zero.
C                   The interval (B,C) collapsed to the requested
C                   tolerance, the function changes sign in (B,C), and
C                   F(X) decreased in magnitude as (B,C) collapsed.
C
C                2  F(B) = 0.  However, the interval (B,C) may not have
C                   collapsed to the requested tolerance.
C
C                3  B may be near a singular point of F(X).
C                   The interval (B,C) collapsed to the requested tol-
C                   erance and the function changes sign in (B,C), but
C                   F(X) increased in magnitude as (B,C) collapsed,i.e.
C                     abs(F(B out)) .GT. max(abs(F(B in)),abs(F(C in)))
C
C                4  No change in sign of F(X) was found although the
C                   interval (B,C) collapsed to the requested tolerance.
C                   The user must examine this case and decide whether
C                   B is near a local minimum of F(X), or B is near a
C                   zero of even multiplicity, or neither of these.
C
C                5  Too many (.GT. 500) function evaluations used.
C      *IPAR     VECTOR OF INTEGER PARAMETERS TO PASS TO F
C***REFERENCES  L. F. SHAMPINE AND H. A. WATTS, *FZERO, A ROOT-SOLVING
C                 CODE*, SC-TM-70-631, SEPTEMBER 1970.
C               T. J. DEKKER, *FINDING A ZERO BY MEANS OF SUCCESSIVE
C                 LINEAR INTERPOLATION*, 'CONSTRUCTIVE ASPECTS OF THE
C                 FUNDAMENTAL THEOREM OF ALGEBRA', EDITED BY B. DEJON
C                 P. HENRICI, 1969.
C***ROUTINES CALLED  R1MACH
C***END PROLOGUE  FZERO
C
      DIMENSION RPAR(1),IPAR(1)
C
C     ER IS TWO TIMES THE COMPUTER UNIT ROUNDOFF VALUE WHICH IS
C     DEFINED HERE BY THE FUNCTION R1MACH.

C***FIRST EXECUTABLE STATEMENT  FZERO
      ER = 2.0 * R1MACH(4)
C
C     INITIALIZE
C
      Z=R
      IF(R.LE.MIN(B,C).OR.R.GE.MAX(B,C)) Z=C
      RW=MAX(RE,ER)
      AW=MAX(AE,0.)
      IC=0
      T=Z
      FZ=F(T,RPAR,IPAR)
      T=B
      FB=F(T,RPAR,IPAR)
      KOUNT=2
      IF(SIGN(1.0,FZ).EQ.SIGN(1.0,FB)) GO TO 1
      C=Z
      FC=FZ
      GO TO 2
    1 IF(Z.EQ.C) GO TO 2
      T=C
      FC=F(T,RPAR,IPAR)
      KOUNT=3
      IF(SIGN(1.0,FZ).EQ.SIGN(1.0,FC)) GO TO 2
      B=Z
      FB=FZ
    2 A=C
      FA=FC
      ACBS=ABS(B-C)
      FX=MAX(ABS(FB),ABS(FC))
C
    3 IF (ABS(FC) .GE. ABS(FB)) GO TO 4
C     PERFORM INTERCHANGE
      A=B
      FA=FB
      B=C
      FB=FC
      C=A
      FC=FA
C
    4 CMB=0.5*(C-B)
      ACMB=ABS(CMB)
      TOL=RW*ABS(B)+AW
C
C     TEST STOPPING CRITERION AND FUNCTION COUNT
C
      IF (ACMB .LE. TOL) GO TO 10
      IF(FB.EQ.0.) GO TO 11
      IF(KOUNT.GE.500) GO TO 14
C
C     CALCULATE NEW ITERATE IMPLICITLY AS B+P/Q
C     WHERE WE ARRANGE P .GE. 0.
C     THE IMPLICIT FORM IS USED TO PREVENT OVERFLOW.
C
      P=(B-A)*FB
      Q=FA-FB
      IF (P .GE. 0.) GO TO 5
      P=-P
      Q=-Q
C
C     UPDATE A AND CHECK FOR SATISFACTORY REDUCTION
C     IN THE SIZE OF THE BRACKETING INTERVAL.
C     IF NOT, PERFORM BISECTION.
C
    5 A=B
      FA=FB
      IC=IC+1
      IF (IC .LT. 4) GO TO 6
      IF (8.*ACMB .GE. ACBS) GO TO 8
      IC=0
      ACBS=ACMB
C
C     TEST FOR TOO SMALL A CHANGE
C
    6 IF (P .GT. ABS(Q)*TOL) GO TO 7
C
C     INCREMENT BY TOLERANCE
C
      B=B+SIGN(TOL,CMB)
      GO TO 9
C
C     ROOT OUGHT TO BE BETWEEN B AND (C+B)/2.
C
    7 IF (P .GE. CMB*Q) GO TO 8
C
C     USE SECANT RULE
C
      B=B+P/Q
      GO TO 9
C
C     USE BISECTION
C
    8 B=0.5*(C+B)
C
C     HAVE COMPLETED COMPUTATION FOR NEW ITERATE B
C
    9 T=B
      FB=F(T,RPAR,IPAR)
      KOUNT=KOUNT+1
C
C     DECIDE WHETHER NEXT STEP IS INTERPOLATION OR EXTRAPOLATION
C
      IF (SIGN(1.0,FB) .NE. SIGN(1.0,FC)) GO TO 3
      C=A
      FC=FA
      GO TO 3
C
C
C     FINISHED. PROCESS RESULTS FOR PROPER SETTING OF IFLAG
C
   10 IF (SIGN(1.0,FB) .EQ. SIGN(1.0,FC)) GO TO 13
      IF (ABS(FB) .GT. FX) GO TO 12
      IFLAG = 1
      RETURN
   11 IFLAG = 2
      RETURN
   12 IFLAG = 3
      RETURN
   13 IFLAG = 4
      RETURN
   14 IFLAG = 5
      RETURN
      END
