      subroutine huberwt(nsct,scale,res,w)
c  computes huber weights based on regression residuals
c
c  input variables
c    nsct-number of sections
c    scale-robust estimate of scale
c    res-vector of absolute value of residuals
c  output variable
c    w-vector of weights
c
      dimension res(nsct),w(nsct)
      do 10 i=1,nsct
        t=res(i)/scale
        if(t.le.1.5)then
          w(i)=1.
        else
          w(i)=1.5/t
        endif
   10   continue
      return
      end
