      subroutine mad(nsct,res,scale)
c
c  rrrmt version 9
c
c  computes median absolute deviation for a Rayleigh variate
c
c  input variables:
c
c  nsct--number of entries in res
c  res--vector of residual magnitudes (overwritten on return)
c
c  output variables:
c
c  scale-mad of entries in res
c
      dimension res(nsct)
      call ssort(res,res,nsct,1)
      do 20 i=1,nsct
   20   if(res(i).ne.0.)goto 21
   21 ni=i
      nl=nsct-ni+1
      if(mod(nl,2).eq.0.)then
        xmed=(res(nl/2+ni-1)+res(nl/2+ni))/2.
      else
        xmed=res(nl/2+ni)
      endif
      do 30 i=ni,nsct
   30   res(i)=abs(res(i)-xmed)
      call ssort(res(ni),res(ni),nl,1)
      if(mod(nl,2).eq.0)then
        scale=(res(nl/2+ni-1)+res(nl/2+ni))/.8969
      else
        scale=res(nl/2+ni)/.44845
      endif
      return
      end
